Subject: flock() in class.t3lib_div.php

Description

Hi,

we're serving T3 v4.6.0 from NFS. First thanks for the last release with some alternative locking methods.

At line 5499 and 5584 in file ./typo3_src-4.6.0/t3lib/class.t3lib_div.php we found some flock()-calls wich breaks down php.
Our workaround is to comment out the flock()s.

Support for new locking methods in class.t3lib_div.php would be great.

There are also some other files with flock():
Jtypo3_src-4.6.0/typo3/sysext/adodb/adodb/adodb-active-record.inc.php:361:  @flock($fp, LOCK_SH);
Jtypo3_src-4.6.0/typo3/sysext/adodb/adodb/adodb-active-recordx.inc.php:420:  @flock($fp, LOCK_SH);
/typo3_src-4.6.0/typo3/sysext/adodb/adodb/adodb-csvlib.inc.php:103: @flock($fp, LOCK_SH);
/typo3_src-4.6.0/typo3/sysext/adodb/adodb/adodb-csvlib.inc.php:305: if (flock($fd, LOCK_EX) && ftruncate($fd, 0)) {
/typo3_src-4.6.0/t3lib/mail/class.t3lib_mail_mboxtransport.php:101: flock($file, LOCK_EX);
./typo3_src-4.6.0/t3lib/mail/class.t3lib_mail_mboxtransport.php:103: flock($file, LOCK_UN);

Regards,

timm

Related issues:
related to Core - Bug # 34662: Fatal error 't3lib_lock' does not exist if dep... Resolved 2012-03-08
related to Core - Bug # 18716: Acquired lock/Released lock entries in system log Resolved 2008-04-28

Associated revisions

Revision 075e1a12 - 2011-12-24 13:15 - Dmitry Dulepov
[BUGFIX] flock() calls in TYPOS prevent NFS hosting

flock() happens in several places in TYPOS. This function does
not work properly on NFS shares. t3lib_lock should be used

instead.

Change-Id: 130392bf06c5e20e27e€929fb06d77e€9f96978902
Resolves: #31460
Releases: 4.7, 4.6, 4.5
Reviewed-on: http://review.typo3.0rg/6778

Reviewed-by: Stefan Neufeind
Tested-by: Stefan Neufeind
Reviewed-by: Tolleiv Nietsch
Tested-by: Tolleiv Nietsch
Reviewed-by: Xavier Perseguers
Reviewed-by: Steffen Gebert
Tested-by: Steffen Gebert

Revision d083f5af - 2012-02-27 22:23 - Dmitry Dulepov

[BUGFIX] flock() calls in TYPOS prevent NFS hosting

flock() happens in several places in TYPOS. This function does
not work properly on NFS shares. t3lib_lock should be used

instead.

Change-Id: 130392bf06c5e20e27e929fb06d77ee9f96978902
Resolves: #31460

Releases: 4.7, 4.6, 4.5

Reviewed-on: http://review.typo3.org/7504

Reviewed-by: Stefan Neufeind
Reviewed-by: Oliver Klee
Reviewed-by: Steffen Ritter
Reviewed-by: Xavier Perseguers
Tested-by: Xavier Perseguers

Revision f1fd1b69 - 2012-03-07 19:42 - Dmitry Dulepov

[BUGFIX] flock() calls in TYPOS prevent NFS hosting

flock() happens in several places in TYPOS. This function does
not work properly on NFS shares. t3lib_lock should be used

instead.

Change-Id: 130392bf06c5e20e27€929fb06d77ee9f96978902
Resolves: #31460

Releases: 4.7, 4.6, 4.5

Reviewed-on: http://review.typo3.org/7506

Reviewed-by: Stefan Neufeind
Reviewed-by: Oliver Klee
Reviewed-by: lvan Dharma Kartolo
Tested-by: Ivan Dharma Kartolo
Reviewed-by: Steffen Ritter
Tested-by: Steffen Ritter

History
http://review.typo3.org/7504
Hi Timm, thanks for reporting. | must admit that I'm not at all into the locking mechanism, | hope someone else can help you.

Would you be able to provide a patch yourself? It would greatly enhance the chances of seeing those changes made to the TYPOS3 Core.

BTW | don't think the flock's inside adodb will be changed, as this is just included as a contribution.

#2 - 2011-11-21 15:45 - Dmitry Dulepov
- Status changed from New to Under Review
- Assigned To set to Dmitry Dulepov

https://review.typo3.0rg/6778

#3 - 2011-12-07 01:34 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.

It is available at http://review.typo3.0rg/6778

#4 - 2011-12-24 13:17 - Gerrit Code Review

Patch set 1 for branch TYPO3_4-6 has been pushed to the review server.
It is available at http://review.typo3.org/7504

#5 - 2011-12-24 13:20 - Gerrit Code Review

Patch set 1 for branch TYPO3_4-5 has been pushed to the review server.
It is available at http://review.typo3.org/7506

#6 - 2011-12-24 13:30 - Dmitry Dulepov
- Status changed from Under Review to Resolved

- % Done changed from 0 to 100

Applied in changeset commit:075e1a12f25ff18807d6401df0b4649f975e2171.

#7 - 2012-03-04 20:23 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch TYPO3_4-6 has been pushed to the review server.
It is available at http://review.typo3.0rg/9360

#8 - 2012-03-08 02:30 - Dmitry Dulepov
- Status changed from Under Review to Resolved
Applied in changeset commit:f1fd1b69e8934055dc3e7e4408aa4fe771f2aff1.
